#pragma once

#include "ANIMATION_COMMON.h"
#include "../../../GAME_COMMON.h"
#include "../../ecs_entity.h"

#include "../component_sprite.h"
#include "../component_text.h"

typedef struct ComponentAnimationStretch
{
	ECSComponent component;
	f32 base;
	f32 multiplier;
	f32 speed;
	u32 timer;
} ComponentAnimationStretch;

void component_animation_stretch_init(ComponentAnimationStretch* self, f32 base, f32 multiplier, f32 speed);
void component_animation_stretch_tick(ComponentAnimationStretch* self, ECS* ecs);

static const ECSComponentInfo COMPONENT_ANIMATION_STRETCH_INFO = 
{
	.system = 
	{
		.functions = 
		{ 
			NULL,
			NULL, 
			(ECSFunction)component_animation_stretch_tick,
			NULL
		}
	},
	.type = ECS_COMPONENT_ANIMATION_STRETCH,
	.size = sizeof(ComponentAnimationStretch)
};
