#include "entity_alert_icon.h"

/* Initializes a alert icon entity. */
void
entity_alert_icon_init(ECS* ecs, u32 id, vec3 position, IconType type)
{
	ComponentActionDeleteOnTimer* actionDeleteOnTimer;
	ComponentAnimationColorChange* animationColorChange;
	ComponentSprite* sprite;

	sprite = ecs_component_add(ecs, ECS_COMPONENT_SPRITE, id);
	actionDeleteOnTimer = ecs_component_add(ecs, ECS_COMPONENT_ACTION_DELETE_ON_TIMER, id);
	animationColorChange = ecs_component_add(ecs, ECS_COMPONENT_ANIMATION_COLOR_CHANGE, id);

	component_sprite_atlas_init
	(
		sprite,
		ecs->game->resources.textures[TEXTURE_ICONS],
		(s32*)ICON_FRAME_SIZE,
		(s32*)ICON_ATLAS_SIZE,
		(f32*)ENTITY_ALERT_ICON_SIZE,
		position
	);

	component_action_delete_on_timer_init
	(
		actionDeleteOnTimer,
		ENTITY_ALERT_ICON_TIMER
	);

	component_animation_color_change_init
	(
		animationColorChange,
		(f32*)COLOR_TRANSPARENT,
		(f32*)COLOR_OPAQUE,
		ENTITY_ALERT_ICON_TIMER,
		ANIMATION_COLOR_CHANGE_MODE_STICK
	);

	sprite->atlas.index = type;
}
