#pragma once

#include "../STATE_COMMON.h"

#include "../../ecs/ecs.h"

#include "../../ecs/entity/entity_cursor.h"
#include "../../ecs/entity/entity_sprite.h"
#include "../../ecs/entity/entity_text.h"
#include "../../ecs/entity/entity_menu_button.h"

static const vec2 GAME_OVER_BACKGROUND_SIZE = {1920.0f, 1080.0f};
static const vec3 GAME_OVER_BACKGROUND_POSITION = {960.0f, 540.0f, 0.2f};
static const vec3 GAME_OVER_TITLE_TEXT_POSITION = {600.0f, 0.0f, 0.09f};
static const vec2 GAME_OVER_IMAGE_SIZE = {1920.0f, 660.0f};
static const vec3 GAME_OVER_IMAGE_POSITION = {960.0f, 450.0f, 0.09f};
static const vec3 GAME_OVER_TEXT_POSITION = {500.0f, 800.0f, 0.1f};
static const vec3 GAME_OVER_MENU_BUTTON_POSITION = {960.0f, 950.0f, 0.1f};

#define GAME_OVER_SHADER_COUNT 2
static const ShaderType GAME_OVER_SHADERS[GAME_OVER_SHADER_COUNT] =
{
	SHADER_TEXTURE_QUAD,
	SHADER_COLOR_QUAD
};

#define GAME_OVER_TEXTURE_COUNT 4
static const TextureType GAME_OVER_TEXTURES[GAME_OVER_TEXTURE_COUNT] =
{
	TEXTURE_STATE_FADE,
	TEXTURE_CURSOR,
	TEXTURE_MENU_BUTTONS,
	TEXTURE_GAME_OVER
};

#define GAME_OVER_FONT_COUNT 2
static const FontType GAME_OVER_FONTS[GAME_OVER_FONT_COUNT] =
{
	FONT_SMALL,
	FONT_BIG
};

#define GAME_OVER_SOUND_COUNT 1
static const SoundType GAME_OVER_SOUNDS[GAME_OVER_SOUND_COUNT] = 
{
	SOUND_SELECT
};

#define GAME_OVER_MUSIC_COUNT 1
static const MusicType GAME_OVER_MUSIC[GAME_OVER_MUSIC_COUNT] =
{
	MUSIC_GAME_OVER
};

void game_over_init(GameOver* self, State* state);
void game_over_tick(GameOver* self);
